using System;
using System.Linq;

namespace Niz
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] Ulaz = Console.ReadLine().Split();
            int n = int.Parse(Ulaz[0]);
            int c = int.Parse(Ulaz[1]);
            int q = int.Parse(Ulaz[2]);
            int[] nizL = new int[q];
            int[] nizR = new int[q];
            string pomNiz = "";
            int sum = 0;

            char[] nizNovcica = Console.ReadLine().ToCharArray();

            for (int i = 0; i < q; i++)
            {
                string[] niz = Console.ReadLine().Split();
                nizL[i] = int.Parse(niz[0]);
                nizR[i] = int.Parse(niz[1]);
            }

            for (int i = 0; i < q; i++)
            {
                for (int j = 0; j < n; j++)
                {
                    if (j >= (nizL[i] - 1) && j <= (nizR[i] - 1))
                    {
                        nizNovcica[j] = PromeniVrednost(nizNovcica[j]);
                    }
                    pomNiz += nizNovcica[j];
                }

                var brojJedinica = nizNovcica.Count(x => x == '1');
                var brojNula = nizNovcica.Count(x => x == '0');
                char[] poslednjiNiz = pomNiz.ToCharArray();

                if (brojJedinica >= brojNula)
                {
                    var pocetniIndeks = pomNiz.IndexOf('1');
                    var poslednjiIndeks = pomNiz.LastIndexOf('1');

                    for (int z = pocetniIndeks; z <= poslednjiIndeks; z++)
                    {
                        poslednjiNiz[z] = PromeniVrednost(poslednjiNiz[z]);
                    }

                    sum += c;
                }

                sum += poslednjiNiz.Count(x => x == '1');

                Console.WriteLine(sum);

                sum = 0;
                pomNiz = "";
            }
        }

        public static char PromeniVrednost(char trenutnaVrednost)
        {
            if (trenutnaVrednost == '1')
            {
                return '0';
            }
            else
            {
                return '1';
            }
        }
    }
}